// Tdef.h        (C) 2004 adolfo@di-mare.com

#ifndef _Tdef_h
#define _Tdef_h

// Aqu se escoge si se usa <string, int> o <string, INT_ZERO> en Tdef.h

#include <iostream>     
// #include "ADH_port.h"
#include "Astring.h"

namespace ADH { // namespace ADH {

typedef  Astring   T1;
typedef  int       T2;

class pair {
public:
    T1 first; T2 second;
    pair() : first( T1() ), second( T2() ) {}
    pair(const T1& a, const T2& b) : first(a), second(b) {}
};

#define T pair          // simula plantillas

inline bool operator < (const pair& l, const pair& r) {
    return l.first < r.first;
}

inline bool operator > (const pair& l, const pair& r) {
    return r < l;
}

inline bool operator == (const pair& l, const pair& r) {
    return !(l < r) && !(r < l);
}

inline bool operator != (const pair& l, const pair& r) {
    return !(l == r);
}

inline bool operator <= (const pair& l, const pair& r) {
    return !(r < l);
}

inline bool operator >= (const pair& l, const pair& r) {
    return !(l < r);
}

inline std::ostream& operator<< (std::ostream &COUT, const pair& t) {
    return COUT << t.first << "->" << t.second;
}

inline std::istream& operator >> (std::istream &CIN, pair& p) {
    return CIN >> p.first >> p.second;
}

#if 1
    #include <assert.h>

    inline bool check_ok( pair P ) {
        assert(false && "check_ok( pair P ==> NO IMPLEMENTADO" );
        return false;
    }
#endif

} // namespace ADH // } // namespace ADH

#endif

// EOF: Tdef.h
